Index: trunk/sources/HeuristicLab.Visualization/3.2/ChartDataRowsModel.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/ChartDataRowsModel.cs	(revision 1880)
+++ trunk/sources/HeuristicLab.Visualization/3.2/ChartDataRowsModel.cs	(revision 1881)
@@ -144,5 +144,5 @@
       }
 
-      XmlNode labelProviderNode = document.ImportNode(XAxis.XAxisLabelProvider.GetLabelProviderXmlNode(), true);
+      XmlNode labelProviderNode = document.ImportNode(XAxis.LabelProvider.GetLabelProviderXmlNode(), true);
       node.AppendChild(labelProviderNode);
 
@@ -155,5 +155,5 @@
       foreach (XmlNode dataRow in node.ChildNodes) {
         if (dataRow.Name.Equals("LabelProvider")) {
-          XAxis.XAxisLabelProvider = XAxis.XAxisLabelProvider.PopulateLabelProviderXmlNode(dataRow);
+          XAxis.LabelProvider = XAxis.LabelProvider.PopulateLabelProviderXmlNode(dataRow);
         } else {
           XmlAttributeCollection attrs = dataRow.Attributes;
Index: trunk/sources/HeuristicLab.Visualization/3.2/DataExport/CSVDataExport.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/DataExport/CSVDataExport.cs	(revision 1880)
+++ trunk/sources/HeuristicLab.Visualization/3.2/DataExport/CSVDataExport.cs	(revision 1881)
@@ -27,5 +27,5 @@
 
         // write headers
-        writer.AddString(model.XAxis.XAxisLabel);
+        writer.AddString(model.XAxis.Label);
         foreach (IDataRow row in model.Rows)
           writer.AddString(row.Label);
Index: trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1880)
+++ trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1881)
@@ -91,5 +91,5 @@
       titleShape.Text = model.Title;
 
-      if (model.XAxis.ShowXAxisGrid) {
+      if (model.XAxis.ShowGrid) {
         canvas.AddShape(xAxisGrid);
       }
@@ -107,6 +107,6 @@
       }
 
-      xAxis.ShowLabel = model.XAxis.ShowXAxisLabel;
-      xAxis.Label = model.XAxis.XAxisLabel;
+      xAxis.ShowLabel = model.XAxis.ShowLabel;
+      xAxis.Label = model.XAxis.Label;
 
       canvas.AddShape(xAxis);
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1880)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1881)
@@ -66,5 +66,5 @@
 
     public void ResetSettings() {
-      model.XAxis.ShowXAxisGrid = oldShowXAxisGrid;
+      model.XAxis.ShowGrid = oldShowXAxisGrid;
 
       foreach (var param in oldLineParams) {
@@ -153,6 +153,6 @@
 
     private void Options_Load(object sender, EventArgs e) {
-      oldShowXAxisGrid = model.XAxis.ShowXAxisGrid;
-      chkShowXAxisGrid.Checked = model.XAxis.ShowXAxisGrid;
+      oldShowXAxisGrid = model.XAxis.ShowGrid;
+      chkShowXAxisGrid.Checked = model.XAxis.ShowGrid;
 
       InitTabPageLines();
@@ -245,5 +245,5 @@
 
     private void chkShowXAxisGrid_CheckedChanged(object sender, EventArgs e) {
-      model.XAxis.ShowXAxisGrid = chkShowXAxisGrid.Checked;
+      model.XAxis.ShowGrid = chkShowXAxisGrid.Checked;
     }
 
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs	(revision 1880)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/OptionsDialog.Designer.cs	(revision 1881)
@@ -60,5 +60,5 @@
       // 
       this.options.Location = new System.Drawing.Point(2, 3);
-      chartDataRowsModel1.XAxis.ShowXAxisLabel = true;
+      chartDataRowsModel1.XAxis.ShowLabel = true;
       chartDataRowsModel1.Title = "Title";
       viewSettings1.LegendColor = System.Drawing.Color.Blue;
@@ -70,6 +70,6 @@
       viewSettings1.XAxisFont = new System.Drawing.Font("Arial", 8F);
       chartDataRowsModel1.ViewSettings = viewSettings1;
-      chartDataRowsModel1.XAxis.XAxisLabel = "";
-      chartDataRowsModel1.XAxis.XAxisLabelProvider = continuousLabelProvider1;
+      chartDataRowsModel1.XAxis.Label = "";
+      chartDataRowsModel1.XAxis.LabelProvider = continuousLabelProvider1;
       this.options.Model = chartDataRowsModel1;
       this.options.Name = "options";
Index: trunk/sources/HeuristicLab.Visualization/3.2/XAxisDescriptor.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/XAxisDescriptor.cs	(revision 1880)
+++ trunk/sources/HeuristicLab.Visualization/3.2/XAxisDescriptor.cs	(revision 1881)
@@ -5,39 +5,39 @@
 
   public class XAxisDescriptor {
-    private string xAxisLabel = "";
-    private bool showXAxisLabel = true;
-    private bool showXAxisGrid = true;
-    private ILabelProvider xAxisLabelProvider = new ContinuousLabelProvider("0.##");
+    private string label = "";
+    private bool showLabel = true;
+    private bool showGrid = true;
+    private ILabelProvider labelProvider = new ContinuousLabelProvider("0.##");
 
     public event XAxisDescriptorChangedHandler XAxisDescriptorChanged;
 
-    public bool ShowXAxisGrid {
-      get { return showXAxisGrid; }
+    public bool ShowGrid {
+      get { return showGrid; }
       set {
-        this.showXAxisGrid = value;
+        this.showGrid = value;
         FireXAxisDescriptorChanged();
       }
     }
 
-    public ILabelProvider XAxisLabelProvider {
-      get { return xAxisLabelProvider; }
+    public ILabelProvider LabelProvider {
+      get { return labelProvider; }
       set {
-        this.xAxisLabelProvider = value;
+        this.labelProvider = value;
         FireXAxisDescriptorChanged();
       }
     }
 
-    public string XAxisLabel {
-      get { return xAxisLabel; }
+    public string Label {
+      get { return label; }
       set {
-        xAxisLabel = value;
+        label = value;
         FireXAxisDescriptorChanged();
       }
     }
 
-    public bool ShowXAxisLabel {
-      get { return showXAxisLabel; }
+    public bool ShowLabel {
+      get { return showLabel; }
       set {
-        showXAxisLabel = value;
+        showLabel = value;
         FireXAxisDescriptorChanged();
       }