Index: trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj	(revision 1883)
+++ trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj	(revision 1885)
@@ -115,4 +115,10 @@
     <Compile Include="LabelProvider\ContinuousLabelProvider.cs" />
     <Compile Include="LabelProvider\DiscreteLabelProvider.cs" />
+    <Compile Include="Options\ColorSelection.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Options\ColorSelection.Designer.cs">
+      <DependentUpon>ColorSelection.cs</DependentUpon>
+    </Compile>
     <Compile Include="XAxisDescriptor.cs" />
     <Compile Include="YAxisGrid.cs" />
@@ -197,4 +203,7 @@
       <SubType>Designer</SubType>
     </EmbeddedResource>
+    <EmbeddedResource Include="Options\ColorSelection.resx">
+      <DependentUpon>ColorSelection.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="Options\Options.resx">
       <DependentUpon>Options.cs</DependentUpon>
Index: trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1883)
+++ trunk/sources/HeuristicLab.Visualization/3.2/LineChart.cs	(revision 1885)
@@ -101,4 +101,5 @@
 
       if (model.XAxis.ShowGrid) {
+        xAxisGrid.Color = model.XAxis.GridColor;
         canvas.AddShape(xAxisGrid);
       }
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.Designer.cs	(revision 1885)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.Designer.cs	(revision 1885)
@@ -0,0 +1,71 @@
+﻿namespace HeuristicLab.Visualization.Options {
+  partial class ColorSelection {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.OptionsDialogSelectColorBtn = new System.Windows.Forms.Button();
+      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // OptionsDialogSelectColorBtn
+      // 
+      this.OptionsDialogSelectColorBtn.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.OptionsDialogSelectColorBtn.Location = new System.Drawing.Point(74, 2);
+      this.OptionsDialogSelectColorBtn.Name = "OptionsDialogSelectColorBtn";
+      this.OptionsDialogSelectColorBtn.Size = new System.Drawing.Size(50, 23);
+      this.OptionsDialogSelectColorBtn.TabIndex = 9;
+      this.OptionsDialogSelectColorBtn.Text = "Select";
+      this.OptionsDialogSelectColorBtn.UseVisualStyleBackColor = true;
+      this.OptionsDialogSelectColorBtn.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
+      // 
+      // ColorPreviewTB
+      // 
+      this.ColorPreviewTB.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.ColorPreviewTB.Location = new System.Drawing.Point(3, 3);
+      this.ColorPreviewTB.Name = "ColorPreviewTB";
+      this.ColorPreviewTB.ReadOnly = true;
+      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
+      this.ColorPreviewTB.TabIndex = 8;
+      // 
+      // ColorSelection
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.OptionsDialogSelectColorBtn);
+      this.Controls.Add(this.ColorPreviewTB);
+      this.Name = "ColorSelection";
+      this.Size = new System.Drawing.Size(126, 25);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button OptionsDialogSelectColorBtn;
+    private System.Windows.Forms.TextBox ColorPreviewTB;
+  }
+}
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.cs	(revision 1885)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.cs	(revision 1885)
@@ -0,0 +1,38 @@
+﻿using System;
+using System.ComponentModel;
+using System.Drawing;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Visualization.Options {
+  public delegate void ColorChangedHandler(ColorSelection sender);
+
+  [DefaultEvent("ColorChanged")]
+  public partial class ColorSelection : UserControl {
+    public ColorSelection() {
+      InitializeComponent();
+    }
+
+    public event ColorChangedHandler ColorChanged;
+
+    public Color Color {
+      get { return ColorPreviewTB.BackColor; }
+      set {
+        ColorPreviewTB.BackColor = value;
+        FireColorChanged();
+      }
+    }
+
+    private void OptionsDialogSelectColorBtn_Click(object sender, EventArgs e) {
+      ColorDialog dlg = new ColorDialog();
+      if (dlg.ShowDialog() == DialogResult.OK) {
+        ColorPreviewTB.BackColor = dlg.Color;
+        FireColorChanged();
+      }
+    }
+
+    private void FireColorChanged() {
+      if (ColorChanged != null)
+        ColorChanged(this);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.resx
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.resx	(revision 1885)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/ColorSelection.resx	(revision 1885)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs	(revision 1883)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.Designer.cs	(revision 1885)
@@ -26,6 +26,4 @@
       this.Optionstabs = new System.Windows.Forms.TabControl();
       this.tabPage1 = new System.Windows.Forms.TabPage();
-      this.OptionsDialogSelectColorBtn = new System.Windows.Forms.Button();
-      this.ColorPreviewTB = new System.Windows.Forms.TextBox();
       this.label2 = new System.Windows.Forms.Label();
       this.LinestyleCB = new System.Windows.Forms.ComboBox();
@@ -46,4 +44,5 @@
       this.btnChangeTitleFont = new System.Windows.Forms.Button();
       this.tpXAxis = new System.Windows.Forms.TabPage();
+      this.chkShowXAxisGrid = new System.Windows.Forms.CheckBox();
       this.btnChangeXAxisFont = new System.Windows.Forms.Button();
       this.tpYAxes = new System.Windows.Forms.TabPage();
@@ -53,5 +52,8 @@
       this.flpShowYAxis = new System.Windows.Forms.FlowLayoutPanel();
       this.fdFont = new System.Windows.Forms.FontDialog();
-      this.chkShowXAxisGrid = new System.Windows.Forms.CheckBox();
+      this.label6 = new System.Windows.Forms.Label();
+      this.groupBox2 = new System.Windows.Forms.GroupBox();
+      this.selectedLineColorSelection = new HeuristicLab.Visualization.Options.ColorSelection();
+      this.xAxisGridColorSelection = new HeuristicLab.Visualization.Options.ColorSelection();
       this.Optionstabs.SuspendLayout();
       this.tabPage1.SuspendLayout();
@@ -63,4 +65,5 @@
       this.gbxYAxisClipChangeable.SuspendLayout();
       this.gbxShowYAxis.SuspendLayout();
+      this.groupBox2.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -81,6 +84,4 @@
       // tabPage1
       // 
-      this.tabPage1.Controls.Add(this.OptionsDialogSelectColorBtn);
-      this.tabPage1.Controls.Add(this.ColorPreviewTB);
       this.tabPage1.Controls.Add(this.label2);
       this.tabPage1.Controls.Add(this.LinestyleCB);
@@ -96,22 +97,4 @@
       this.tabPage1.UseVisualStyleBackColor = true;
       // 
-      // OptionsDialogSelectColorBtn
-      // 
-      this.OptionsDialogSelectColorBtn.Location = new System.Drawing.Point(217, 126);
-      this.OptionsDialogSelectColorBtn.Name = "OptionsDialogSelectColorBtn";
-      this.OptionsDialogSelectColorBtn.Size = new System.Drawing.Size(50, 23);
-      this.OptionsDialogSelectColorBtn.TabIndex = 7;
-      this.OptionsDialogSelectColorBtn.Text = "Select";
-      this.OptionsDialogSelectColorBtn.UseVisualStyleBackColor = true;
-      this.OptionsDialogSelectColorBtn.Click += new System.EventHandler(this.OptionsDialogSelectColorBtn_Click);
-      // 
-      // ColorPreviewTB
-      // 
-      this.ColorPreviewTB.Location = new System.Drawing.Point(146, 127);
-      this.ColorPreviewTB.Name = "ColorPreviewTB";
-      this.ColorPreviewTB.ReadOnly = true;
-      this.ColorPreviewTB.Size = new System.Drawing.Size(64, 20);
-      this.ColorPreviewTB.TabIndex = 6;
-      // 
       // label2
       // 
@@ -154,4 +137,5 @@
       // groupBox1
       // 
+      this.groupBox1.Controls.Add(this.selectedLineColorSelection);
       this.groupBox1.Controls.Add(this.MarkercheckBox);
       this.groupBox1.Controls.Add(this.label4);
@@ -287,5 +271,5 @@
       // tpXAxis
       // 
-      this.tpXAxis.Controls.Add(this.chkShowXAxisGrid);
+      this.tpXAxis.Controls.Add(this.groupBox2);
       this.tpXAxis.Controls.Add(this.btnChangeXAxisFont);
       this.tpXAxis.Location = new System.Drawing.Point(4, 22);
@@ -295,4 +279,16 @@
       this.tpXAxis.Text = "X-Axis";
       this.tpXAxis.UseVisualStyleBackColor = true;
+      // 
+      // chkShowXAxisGrid
+      // 
+      this.chkShowXAxisGrid.AutoSize = true;
+      this.chkShowXAxisGrid.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
+      this.chkShowXAxisGrid.Location = new System.Drawing.Point(20, 28);
+      this.chkShowXAxisGrid.Name = "chkShowXAxisGrid";
+      this.chkShowXAxisGrid.Size = new System.Drawing.Size(56, 17);
+      this.chkShowXAxisGrid.TabIndex = 3;
+      this.chkShowXAxisGrid.Text = "Visible";
+      this.chkShowXAxisGrid.UseVisualStyleBackColor = true;
+      this.chkShowXAxisGrid.CheckedChanged += new System.EventHandler(this.chkShowXAxisGrid_CheckedChanged);
       // 
       // btnChangeXAxisFont
@@ -360,14 +356,42 @@
       this.flpShowYAxis.TabIndex = 0;
       // 
-      // chkShowXAxisGrid
-      // 
-      this.chkShowXAxisGrid.AutoSize = true;
-      this.chkShowXAxisGrid.Location = new System.Drawing.Point(3, 32);
-      this.chkShowXAxisGrid.Name = "chkShowXAxisGrid";
-      this.chkShowXAxisGrid.Size = new System.Drawing.Size(107, 17);
-      this.chkShowXAxisGrid.TabIndex = 3;
-      this.chkShowXAxisGrid.Text = "Show X-Axis Grid";
-      this.chkShowXAxisGrid.UseVisualStyleBackColor = true;
-      this.chkShowXAxisGrid.CheckedChanged += new System.EventHandler(this.chkShowXAxisGrid_CheckedChanged);
+      // label6
+      // 
+      this.label6.AutoSize = true;
+      this.label6.Location = new System.Drawing.Point(20, 55);
+      this.label6.Name = "label6";
+      this.label6.Size = new System.Drawing.Size(31, 13);
+      this.label6.TabIndex = 5;
+      this.label6.Text = "Color";
+      // 
+      // groupBox2
+      // 
+      this.groupBox2.Controls.Add(this.label6);
+      this.groupBox2.Controls.Add(this.xAxisGridColorSelection);
+      this.groupBox2.Controls.Add(this.chkShowXAxisGrid);
+      this.groupBox2.Location = new System.Drawing.Point(8, 42);
+      this.groupBox2.Name = "groupBox2";
+      this.groupBox2.Size = new System.Drawing.Size(205, 94);
+      this.groupBox2.TabIndex = 6;
+      this.groupBox2.TabStop = false;
+      this.groupBox2.Text = "Grid";
+      // 
+      // selectedLineColorSelection
+      // 
+      this.selectedLineColorSelection.Color = System.Drawing.SystemColors.Control;
+      this.selectedLineColorSelection.Location = new System.Drawing.Point(142, 73);
+      this.selectedLineColorSelection.Name = "selectedLineColorSelection";
+      this.selectedLineColorSelection.Size = new System.Drawing.Size(121, 25);
+      this.selectedLineColorSelection.TabIndex = 10;
+      this.selectedLineColorSelection.ColorChanged += new HeuristicLab.Visualization.Options.ColorChangedHandler(this.selectedLineColorSelection_ColorChanged);
+      // 
+      // xAxisGridColorSelection
+      // 
+      this.xAxisGridColorSelection.Color = System.Drawing.SystemColors.Control;
+      this.xAxisGridColorSelection.Location = new System.Drawing.Point(54, 49);
+      this.xAxisGridColorSelection.Name = "xAxisGridColorSelection";
+      this.xAxisGridColorSelection.Size = new System.Drawing.Size(126, 25);
+      this.xAxisGridColorSelection.TabIndex = 4;
+      this.xAxisGridColorSelection.ColorChanged += new HeuristicLab.Visualization.Options.ColorChangedHandler(this.xAxisGridColorSelection_ColorChanged);
       // 
       // Options
@@ -389,5 +413,4 @@
       this.tpTitle.PerformLayout();
       this.tpXAxis.ResumeLayout(false);
-      this.tpXAxis.PerformLayout();
       this.tpYAxes.ResumeLayout(false);
       this.tpYAxes.PerformLayout();
@@ -396,4 +419,6 @@
       this.gbxShowYAxis.ResumeLayout(false);
       this.gbxShowYAxis.PerformLayout();
+      this.groupBox2.ResumeLayout(false);
+      this.groupBox2.PerformLayout();
       this.ResumeLayout(false);
 
@@ -404,6 +429,4 @@
     private System.Windows.Forms.TabControl Optionstabs;
     private System.Windows.Forms.TabPage tabPage1;
-    private System.Windows.Forms.Button OptionsDialogSelectColorBtn;
-    private System.Windows.Forms.TextBox ColorPreviewTB;
     private System.Windows.Forms.Label label2;
     private System.Windows.Forms.ComboBox LinestyleCB;
@@ -432,4 +455,8 @@
     private System.Windows.Forms.TextBox tbxTitle;
     private System.Windows.Forms.Label label5;
+    private ColorSelection selectedLineColorSelection;
+    private System.Windows.Forms.GroupBox groupBox2;
+    private System.Windows.Forms.Label label6;
+    private ColorSelection xAxisGridColorSelection;
   }
 }
Index: trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1883)
+++ trunk/sources/HeuristicLab.Visualization/3.2/Options/Options.cs	(revision 1885)
@@ -14,4 +14,5 @@
     private Dictionary<CheckBox, bool> ShowYAxisBoxes;
     private bool oldShowXAxisGrid;
+    private Color oldXAxisGridColor;
     private Dictionary<CheckBox, bool> yAxisClipChangeableBoxes;
 
@@ -67,4 +68,8 @@
     public void ResetSettings() {
       model.XAxis.ShowGrid = oldShowXAxisGrid;
+      chkShowXAxisGrid.Checked = oldShowXAxisGrid;
+      
+      model.XAxis.GridColor = oldXAxisGridColor;
+      xAxisGridColorSelection.Color = oldXAxisGridColor;
 
       foreach (var param in oldLineParams) {
@@ -95,11 +100,4 @@
     }
 
-    private void OptionsDialogSelectColorBtn_Click(object sender, EventArgs e) {
-      ColorDialog dlg = new ColorDialog();
-      dlg.ShowDialog();
-      ColorPreviewTB.BackColor = dlg.Color;
-      ((IDataRow)LineSelectCB.SelectedValue).Color = dlg.Color;
-    }
-
     private static IList<int> GetThicknesses() {
       return new List<int>(new[] {1, 2, 3, 4, 5, 6, 7, 8});
@@ -155,4 +153,7 @@
       oldShowXAxisGrid = model.XAxis.ShowGrid;
       chkShowXAxisGrid.Checked = model.XAxis.ShowGrid;
+
+      oldXAxisGridColor = model.XAxis.GridColor;
+      xAxisGridColorSelection.Color = model.XAxis.GridColor;
 
       InitTabPageLines();
@@ -216,5 +217,5 @@
         LineThicknessCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Thickness;
         LinestyleCB.SelectedItem = ((IDataRow)LineSelectCB.SelectedValue).Style;
-        ColorPreviewTB.BackColor = ((IDataRow)LineSelectCB.SelectedValue).Color;
+        selectedLineColorSelection.Color = ((IDataRow)LineSelectCB.SelectedValue).Color;
         MarkercheckBox.Checked = ((IDataRow)LineSelectCB.SelectedValue).ShowMarkers;
       }
@@ -252,4 +253,12 @@
       model.ViewSettings.UpdateView();
     }
+
+    private void selectedLineColorSelection_ColorChanged(ColorSelection sender) {
+      ((IDataRow)LineSelectCB.SelectedValue).Color = selectedLineColorSelection.Color;
+    }
+
+    private void xAxisGridColorSelection_ColorChanged(ColorSelection sender) {
+      model.XAxis.GridColor = xAxisGridColorSelection.Color;
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Visualization/3.2/XAxisDescriptor.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/XAxisDescriptor.cs	(revision 1883)
+++ trunk/sources/HeuristicLab.Visualization/3.2/XAxisDescriptor.cs	(revision 1885)
@@ -1,2 +1,3 @@
+using System.Drawing;
 using HeuristicLab.Visualization.LabelProvider;
 
@@ -8,4 +9,5 @@
     private bool showLabel = true;
     private bool showGrid = true;
+    private Color gridColor = Color.LightBlue;
     private ILabelProvider labelProvider = new ContinuousLabelProvider("0.##");
 
@@ -44,4 +46,12 @@
     }
 
+    public Color GridColor {
+      get { return this.gridColor; }
+      set {
+        this.gridColor = value;
+        FireXAxisDescriptorChanged();
+      }
+    }
+
     private void FireXAxisDescriptorChanged() {
       if (XAxisDescriptorChanged != null)