Index: trunk/sources/HeuristicLab.Visualization/3.2/ChartDataModelBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/ChartDataModelBase.cs	(revision 1885)
+++ 	(revision )
@@ -1,10 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Visualization {
-  public abstract class ChartDataModelBase : ItemBase, IChartDataModel{
-  }
-}
Index: trunk/sources/HeuristicLab.Visualization/3.2/ChartDataRowsModel.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/ChartDataRowsModel.cs	(revision 1885)
+++ trunk/sources/HeuristicLab.Visualization/3.2/ChartDataRowsModel.cs	(revision 1886)
@@ -12,13 +12,25 @@
   public delegate void ModelChangedHandler();
 
-  public class ChartDataRowsModel : ChartDataModelBase, IChartDataRowsModel{
+  public class ChartDataRowsModel : ItemBase, IChartDataRowsModel {
     private string title = "Title";
-
     private ViewSettings viewSettings = new ViewSettings();
-
     private readonly XAxisDescriptor xAxisDescriptor = new XAxisDescriptor();
+    private readonly YAxisDescriptor defaultYAxisDescriptor = new YAxisDescriptor();
+    private readonly List<IDataRow> rows = new List<IDataRow>();
 
     public ChartDataRowsModel() {
       this.XAxis.XAxisDescriptorChanged += delegate { OnModelChanged(); };
+    }
+
+    public override IView CreateView() {
+      return new LineChart(this);
+    }
+
+    public string Title {
+      get { return title; }
+      set {
+        title = value;
+        OnModelChanged();
+      }
     }
 
@@ -39,24 +51,11 @@
     }
 
-
-    private readonly List<IDataRow> rows = new List<IDataRow>();
+    public YAxisDescriptor DefaultYAxis {
+      get { return defaultYAxisDescriptor; }
+    }
 
     public List<IDataRow> Rows{
       get { return rows; }
     }
-
-    public string Title {
-      get { return title; }
-      set {
-        title = value;
-        OnModelChanged();
-      }
-    }
-
-    public override IView CreateView() {
-      return new LineChart(this);
-    }
-
-    private readonly YAxisDescriptor defaultYAxisDescriptor = new YAxisDescriptor();
 
     public void AddDataRow(IDataRow row) {
@@ -71,8 +70,4 @@
       rows.Remove(row);
       OnDataRowRemoved(row);
-    }
-
-    public YAxisDescriptor DefaultYAxis {
-      get { return defaultYAxisDescriptor; }
     }
 
Index: trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj	(revision 1885)
+++ trunk/sources/HeuristicLab.Visualization/3.2/HeuristicLab.Visualization-3.2.csproj	(revision 1886)
@@ -97,5 +97,4 @@
     </Compile>
     <Compile Include="ChangeType.cs" />
-    <Compile Include="ChartDataModelBase.cs" />
     <Compile Include="ChartDataRowsModel.cs" />
     <Compile Include="ChartDataRowsModelDummy.cs" />
@@ -150,5 +149,4 @@
     <Compile Include="DrawingStyle.cs" />
     <Compile Include="HeuristicLabVisualizationPlugin.cs" />
-    <Compile Include="IChartDataModel.cs" />
     <Compile Include="IChartDataRowsModel.cs" />
     <Compile Include="IDataRow.cs" />
Index: trunk/sources/HeuristicLab.Visualization/3.2/IChartDataModel.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/IChartDataModel.cs	(revision 1885)
+++ 	(revision )
@@ -1,10 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Visualization {
-  interface IChartDataModel : IItem {
-  }
-}
Index: trunk/sources/HeuristicLab.Visualization/3.2/IChartDataRowsModel.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/3.2/IChartDataRowsModel.cs	(revision 1885)
+++ trunk/sources/HeuristicLab.Visualization/3.2/IChartDataRowsModel.cs	(revision 1886)
@@ -1,5 +1,4 @@
 ﻿using System.Collections.Generic;
 using HeuristicLab.Core;
-using HeuristicLab.Visualization.LabelProvider;
 using HeuristicLab.Visualization.Options;
 
@@ -7,9 +6,9 @@
   public interface IChartDataRowsModel : IItem {
     string Title { get; set; }
-    List<IDataRow> Rows { get; }
 
     XAxisDescriptor XAxis { get; }
     List<YAxisDescriptor> YAxes { get; }
 
+    List<IDataRow> Rows { get; }
     void AddDataRow(IDataRow row);
     void RemoveDataRow(IDataRow row);